% POP:
% Parametry zmienne w czasie:
syms alfa z l2
% Parametry stałe w czasie:
l1=0.7; h=0.05;
% Współrzędne punktu Q (końcówka manipulatora) w układzie globalnym
xSQ = l1*cos(alfa)+l2*cos(alfa);
ySQ = l1*sin(alfa)+l2*sin(alfa);
zSQ = h+z;
% Rozwiązać równanie (poszukiwanie wartości parametrów, które zmieniają się w czasie) dla 
% współrzędnych punktów, który ma osiągnąć końcówka manipulatora
[alfa1 z1 l21]=solve(xSQ==1, ySQ==-0.4, zSQ==0.1, [alfa z l2])
[alfa2 z2 l22]=solve(xSQ==-0.8, ySQ==-0.9, zSQ==0.7, [alfa z l2])
% Jeżeli istnieje więcej niż jedno rozwiązanie, należy obliczone poszukiwane zmienne wstawić 
% do współrzędnych poszczególnych punktów (przegubów) i narysować, jakie położenia osiągną 
% ramiona manipulatora, żeby wyeliminować błędne rozwiązania.

alfa1=-0.3805;
l21=0.3770;
z1=0.0500;

alfa2=-2.2974;
l22=0.5042;
z2=0.6500;

S_alfa=alfa2-alfa1;
S_l2=l22-l21;
S_z=z2-z1;

% Przyjęte maksymalne prędkości silników
V_ang=0.1;
V_lin=0.1;

% Określenie kierunku obrotu silników przy maksymalnych prędkościach
Vd_alfa=sign(S_alfa)*V_ang;
Vd_l2=sign(S_l2)*V_lin;
Vd_z=sign(S_z)*V_lin;

% Parametry czasowe
t0=0; % start
tk=100; % koniec
t=t0:0.1:tk;
tz=5; % czas rozpędzania i hamowania silników

% Czas potrzebny do wykonania zadania
T_alfa=(S_alfa/Vd_alfa)-tz;
T_l2=(S_l2/Vd_l2)-tz;
T_z=(S_z/Vd_z)-tz;

% Praca silników - prędkości
V_alfa=(Vd_alfa/tz).*(heaviside(t-t0).*(t-t0)-heaviside(t-t0-tz).*(t-t0-tz)-heaviside(t-t0-tz-T_alfa).*(t-t0-tz-T_alfa)+heaviside(t-t0-2*tz-T_alfa).*(t-t0-2*tz-T_alfa));
V_l2=(Vd_l2/tz).*(heaviside(t-t0).*(t-t0)-heaviside(t-t0-tz).*(t-t0-tz)-heaviside(t-t0-tz-T_l2).*(t-t0-tz-T_l2)+heaviside(t-t0-2*tz-T_l2).*(t-t0-2*tz-T_l2));
V_z=(Vd_z/tz).*(heaviside(t-t0).*(t-t0)-heaviside(t-t0-tz).*(t-t0-tz)-heaviside(t-t0-tz-T_z).*(t-t0-tz-T_z)+heaviside(t-t0-2*tz-T_z).*(t-t0-2*tz-T_z));

% Przyspieszenia
A_alfa=(Vd_alfa/tz).*(heaviside(t-t0)-heaviside(t-t0-tz)-heaviside(t-t0-tz-T_alfa)+heaviside(t-t0-2*tz-T_alfa));
A_l2=(Vd_l2/tz).*(heaviside(t-t0)-heaviside(t-t0-tz)-heaviside(t-t0-tz-T_l2)+heaviside(t-t0-2*tz-T_l2));
A_z=(Vd_z/tz).*(heaviside(t-t0)-heaviside(t-t0-tz)-heaviside(t-t0-tz-T_z)+heaviside(t-t0-2*tz-T_z));

% Przemieszczenia
Q_alfa=(Vd_alfa/(2*tz)).*(heaviside(t-t0).*((t-t0).^2)-heaviside(t-t0-tz).*((-t+t0+tz).^2)-heaviside(t-t0-tz-T_alfa).*((-t+t0+tz+T_alfa)).^2+heaviside(t-t0-2*tz-T_alfa).*((-t+t0+2*tz+T_alfa).^2));
Q_l2=(Vd_l2/(2*tz)).*(heaviside(t-t0).*((t-t0).^2)-heaviside(t-t0-tz).*((-t+t0+tz).^2)-heaviside(t-t0-tz-T_l2).*((-t+t0+tz+T_l2)).^2+heaviside(t-t0-2*tz-T_l2).*((-t+t0+2*tz+T_l2).^2));
Q_z=(Vd_z/(2*tz)).*(heaviside(t-t0).*((t-t0).^2)-heaviside(t-t0-tz).*((-t+t0+tz).^2)-heaviside(t-t0-tz-T_z).*((-t+t0+tz+T_z)).^2+heaviside(t-t0-2*tz-T_z).*((-t+t0+2*tz+T_z).^2));

figure(1);
plot(t,V_alfa,t,V_l2,'r',t,V_z,'g');
figure(2);
plot(t,A_alfa,t,A_l2,'r',t,A_z,'g');
figure(3);
plot(t,Q_alfa,t,Q_l2,'r',t,Q_z,'g');

plotuj(l1,l21,h,alfa1,z1,l1,l22,h,alfa2,z2,4);

function res = plotuj(l1, l2, h, alfa, z, l11, l21, h1, alfa1, z1, i)

    Z = [0, h, h+z, h+z, h+z];

    Y = [0,
         0, 
         0,
         l1*sin(alfa),
         l1*sin(alfa)+l2*sin(alfa)];

    X = [0,
         0, 
         0,
         l1*cos(alfa),
         l1*cos(alfa)+l2*cos(alfa)];

    Z1 = [0, h1, h1+z1, h1+z1, h1+z1];

    Y1 = [0,
         0, 
         0,
         l11*sin(alfa1),
         l11*sin(alfa1)+l21*sin(alfa1)];

    X1 = [0,
         0, 
         0,
         l11*cos(alfa1),
         l11*cos(alfa1)+l21*cos(alfa1)];

    zeroes = [0,0,0,0,0];

    figure(i);
    plot3(X,Y,Z);
    hold on;
    plot3(X1,Y1,Z1);
end

